package com.example.infocheck.datas

import com.example.infocheck.datas.models.News
import com.example.infocheck.datas.models.QueryInfo
import com.example.infocheck.ui.viewmodel.NewsDetailViewModel
import com.example.infocheck.ui.viewmodel.NewsListViewModel
import kotlinx.coroutines.Job
import kotlinx.coroutines.flow.Flow

//interface used by viewmodel to manipulate Data class (generated by dagger hilt and injected into viewmodels)
interface DatasRepository {


    fun downloadNews(downloadJob: Job?, forceDownload: Boolean):  Flow<NewsListViewModel.NewsUiState>
    fun getNews(position: Int): News

    fun saveNews(position : Int) : Flow<NewsDetailViewModel.SaveState>
    fun getListSavedNews(): Flow<List<News>>
    fun getSavedNews(position: Int): News
    fun deleteNews(position: Int): Flow<List<News>>

    fun addQuery(queryInfo: QueryInfo): Flow<ArrayList<QueryInfo>>
    fun removeQuery(queryInfo : QueryInfo) : Flow<ArrayList<QueryInfo>>
    fun getAllQuery() : Flow<List<QueryInfo>>





}